<script setup lang="ts">
import { computed, ref, watch } from 'vue'

import ProductList from '@/components/ProductList.vue'
import ReceiptItemList from '@/components/ReceiptItemList.vue'
import MemberSearch from '@/components/MemberSearch.vue'

import { useAuthStore } from '@/stores/auth'
import { usePosStore } from '@/stores/pos'
import { type ReceiptItem } from '@/types/ReceiptItem'
import { type Product } from '@/types/Product'
import type { Receipt } from '@/types/Receipt'
import ReceiptPaper from './ReceiptPaper.vue'
import { onMounted } from 'vue'
import type { Member } from '@/types/Member'
import { useReceiptStore } from '@/stores/receipt'

const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const posStore = usePosStore()

const snackbar = ref(false)
const log = ref('')
const pay = ref(0)
const product = ref<Product>()
const receiptItemList = ref<typeof ReceiptItemList | null>(null)
const dialogReceipt = ref(false)
function selected(p: Product) {
  if (!p.id) return
  product.value = p
  //
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    productId: p.id
  }
  receiptStore.addReceiptItem(newReceiptItem)
  snackbar.value = true
}


const currentUser = authStore.getCurrentUser()

const clearForm = () => {
  receiptStore.initReceipt()
}



// const refreshReceiptItems = () => {
//   receiptStore.receiptItems.value = [...receiptItems.value]
// }

const tab = ref(null)
onMounted(async () => {
  await posStore.getProducts()
})
// const showReceipt = function(){
//     receiptStore.showReceiptDialog()
// }
function selectedMember(member: Member) { }
</script>

<template>
  <v-container>
    <v-row>
      <v-col cols="12" md="6" style="background-color:#8B7565;">
        <v-sheet max-width="600" min-width="300" height="720" elevation="3" class="overflow-auto">
          <v-tabs v-model="tab" color="deep-purple-accent-4" align-tabs="center" style="background-color:#D7CCC8">
            <v-tab :value="1">เครื่องดื่ม</v-tab>
            <v-tab :value="2">ขนม</v-tab>
            <v-tab :value="3">อาหาร</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="posStore.products1" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="posStore.products2" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="posStore.products3" @selected="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>
      <v-col cols="12" md="6" style="background-color:#8B7565;">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <ReceiptItemList v-model="receiptStore.receiptItems" :editable="true"></ReceiptItemList>
            </v-col>
            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="80" elevation="3">
                <MemberSearch></MemberSearch>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="200" elevation="6">
                <v-container style="text-align: left">
                  <v-row>
                    <v-col class="text-h7" cols="6">รวมเงิน : {{ receiptStore.receipt.total }} บาท</v-col>
                    <v-col class="text-h7" cols="6">เงินทอน : {{ pay >= receiptStore.receipt.total ? pay -
                      receiptStore.receipt.total : 0 }} บาท</v-col>
                    <v-col class="text-h7" cols="12">รวม : {{ receiptStore.receipt.amount }} ชิ้น</v-col>
                   
                    <v-col class="text-h7" cols="6">ช่องรับเงิน</v-col>
                    <v-text-field v-model="pay" density="compact" variant="solo" label="Payment"
                      append-inner-icon="mdi-currency-usd" single-line hide-details @keyup.enter="onClick(pay)"
                      style="padding-left: 0%; width: 100; max-width: 100%"></v-text-field>
                    <v-col>

                    </v-col>
                  </v-row>

                </v-container>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet max-width="600" min-width="300" height="87" elevation="3">
                <v-container style="text-align: center">
                  <v-row>
                    <v-col><v-btn block rounded="lg" color="#E7564B" size="x-large" elevation="2" @click="() => {
                      clearForm()
                    }
                      ">ยกเลิก</v-btn></v-col>
                    <v-col>
                      <v-btn block rounded="lg" color="rgb(107, 179, 62)" size="x-large" elevation="2"
                        @click="dialogReceipt = true">ชำระเงิน</v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <ReceiptPaper v-model:modelValue="dialogReceipt" :receipt="receiptStore.receipt"
    :receiptItems="receiptStore.receiptItems" @agree="() => {
      receiptStore.order()
    }"></ReceiptPaper>
  <ReceiptDialog></ReceiptDialog>

</template>
